/*
 * @Description: 
 * @Version: 2.0
 * @Autor: ruog__
 * @Date: 2022-04-22 15:24:58
 * @LastEditors: ruog__
 * @LastEditTime: 2022-07-29 11:39:27
 */
#ifndef __UOS_HWID_H__
#define __UOS_HWID_H__

#include "./uos_hwinfo.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __OUTPUT__
#define __OUTPUT__ //出参标记
#define __INPUT__  //入参标记
#endif

////////////////////////////////////HWID ID STRUCT////////////////////////////////////////


////////////////////////////////////HWID ID STRUCT////////////////////////////////////////
#define HWID_LEN 124
/**
 * 获取hwid
*/
#pragma pack (1)
typedef struct _hwidInfo
{
    /* data */
    unsigned char hwid[HWID_LEN+1]; //124字节  hwid长度
    unsigned char reserved[899];//预留
}hwidInfo;
#pragma pack ()

enum hwidFlag
{
    Board = 0x1,
    System = 0x2,
    Cpu = 0x4,
    Net = 0X8,
    Disk = 0x10
};

////////////////////////////////////HWID ID INTERFACE////////////////////////////////////////
int uoshwinfo_deviceh_get_hwid(hwidInfo *);


/**
 * @brief hwid1和hwid2 flag标记的硬件信息是否匹配
 * 
 * @param isMatched:是否相同 ： 1.相同  0.不相同  2.hwid1 or hwid2 无效（非法hwid）
 * @return 0:接口执行成功。 -1：接口执行失败，参数值不可取
 */
int uoshwinfo_deviceh_is_hwid_matched(hwidInfo __INPUT__ *hwid1, hwidInfo __INPUT__ *hwid2, int __INPUT__ flag, int __OUTPUT__ *isMatched);
////////////////////////////////////HWID ID INTERFACE////////////////////////////////////////

/**
 * @brief 替换hwid某个flag值，然后重新生成hwid，放入到传入的hwid中替换原来hwid
 * 
 * @param hwid 
 * @param flag 
 * @param value 
 * @return int 
 */
int uoshwinfo_deviceh_replace_flag(hwidInfo __INPUT__ __OUTPUT__ *hwid, int __INPUT__ flag, char __INPUT__ *value);

/**
 * @brief 从这个hwid中取出对应标记的哈希值。  此接口一次只能取一个标记，flag不能传“与”操作后的数据。   后续添加复合flag功能
 * 
 * @param hwid 
 * @param flag 
 * @param hash 
 * @return int 
 */
int uoshwinfo_deviceh_getvalue(hwidInfo __INPUT__ *hwid, int __INPUT__ flag, char __OUTPUT__ hash[25]);

#ifdef __cplusplus
}
#endif
#endif //__UOS_HWID_H__
