#ifndef __UOS_OSID_H__
#define __UOS_OSID_H__


#ifdef __cplusplus
extern "C" {
#endif


////////////////////////////////////OSID ID INTERFACE////////////////////////////////////////
/*
  function:校验OSID完整性
  input: p_osid --- osid缓存
  output: N/A
  return: -1 --- 校验OSID失败
           0 --- 校验OSID成功
*/
int uoshwinfo_osid_checksum(char *p_osid);


/*
  function:解析OSID版本号
  input: p_osid --- osid缓存
  output: pver --- OSID版本号
  return: -1 --- 解析OSID版本号失败
           0 --- 解析OSID版本号成功
*/
int uoshwinfo_osid_parse_ver(char *p_osid, unsigned char *pver);


/*
  function:获取当前操作系统OSID
  input: osid --- osid缓存
         osid_len --- osid缓存大小
         ver --- osid版本号, 版本号从0x01开始，0x00为默认值
  output: osid --- osid结果
  return: -1 --- 获取osid失败
           0 --- 获取osid成功
*/
int uoshwinfo_osid_get_id(char *p_osid, int osid_len, unsigned char ver);


/*
  function:根据传入的uuid生成OSID
  input: osid --- osid缓存
         osid_len --- osid缓存大小
         ver --- osid版本号, 版本号从0x01开始，0x00为默认值
         uuid --- 传入的uuid
  output: osid --- osid结果
  return: -1 --- 获取osid失败
           0 --- 获取osid成功
*/
int uoshwinfo_generate_osid_by_uuid(char *p_osid, int osid_len, unsigned char ver, char *uuid);
////////////////////////////////////OSID ID INTERFACE////////////////////////////////////////



#ifdef __cplusplus
}
#endif
#endif //__UOS_OSID_H__
